#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <math.h>

using namespace std;

typedef long long ll;
#define all(a) a.begin(), a.end()


int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    ll k, n;
    cin >> k >> n;
    set<pair<ll, ll>> a;
    ll ans = 0;
    vector<vector<pair<int, int>>> now(k, vector<pair<int, int>>(k));
    auto p = make_pair(0, k);
    for (int i = 0; i < k; i++) {
        for (int j = 0; j < k; j++) {
            now[i][j] = {j, i};
            a.insert(now[i][j]);
            ans++;
        }
    }
    while (n--) {
        char q;
        ll x;
        cin >> q >> x;
        if (q == 'N') {
            while (x--) {
                for (int i = 0; i < k; i++) {
                    for (int j = 0; j < k; j++) {
                        now[i][j].second++;
                        if (a.find(now[i][j]) == a.end()) {
                            ans++;
                            a.insert(now[i][j]);
                        }
                    }
                }
            }
        }
        if (q == 'S') {
            while (x--) {
                for (int i = 0; i < k; i++) {
                    for (int j = 0; j < k; j++) {
                        now[i][j].second--;
                        if (a.find(now[i][j]) == a.end()) {
                            ans++;
                            a.insert(now[i][j]);
                        }
                    }
                }
            }
        }
        if (q == 'W') {
            while (x--) {
                for (int i = 0; i < k; i++) {
                    for (int j = 0; j < k; j++) {
                        now[i][j].first--;
                        if (a.find(now[i][j]) == a.end()) {
                            ans++;
                            a.insert(now[i][j]);
                        }
                    }
                }
            }
        }
        if (q == 'E') {
            while (x--) {
                for (int i = 0; i < k; i++) {
                    for (int j = 0; j < k; j++) {
                        now[i][j].first++;
                        if (a.find(now[i][j]) == a.end()) {
                            ans++;
                            a.insert(now[i][j]);
                        }
                    }
                }
            }
        }
    }
    cout << ans;
}